# Contributing to MicroStream

We love your input! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features
- Becoming a maintainer

## We Develop with Github

We use GitHub to host code, to track issues and feature requests, as well as accept pull requests.

## All Code Changes Happen Through Pull Requests

Pull requests are the best way to propose changes to the codebase. We actively welcome your pull requests:

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update the documentation.
4. Ensure the test suite passes.
5. Issue that pull request!

## Any contributions you make will be under the Eclipse Public License

In short, when you submit code changes, your submissions are understood to be under the same [EPL-2.0 License](https://github.com/microstream-one/microstream/blob/master/LICENSE) that covers the project. Feel free to contact the maintainers if that's a concern.

## Report bugs using Github's [issues](https://github.com/microstream-one/microstream/issues)

We use GitHub issues to track public bugs. Report a bug by opening a new issue, it's that easy!

## License

By contributing, you agree that your contributions will be licensed under its Eclipse Public License.

## Code of Conduct

Please follow our [Code of Conduct](CODE_OF_CONDUCT.md).
